#include <stdlib.h>
#include <string.h>
#include <sys/types.h>

#include "arch.h"
#include "bool.h"
#include "msg.h"
#include "opts.h"
#include "str.h"



extern char **environ;



void unset_env(const char *var, size_t len) {
	unsigned int found = 0, pos;

	for (pos = 0; environ[pos] != NULL; ++pos) {
		if (strncmp(environ[pos], var, len) == 0 && environ[pos][len] == '=')
			found = 1;
		environ[pos] = environ[pos + found];
	}
}


BOOL set_global_env(void) {
	if (Verbose) {
		if (putenv("Verbose=") != 0)
			return FALSE;
	} else
		unset_env("Verbose", 7);

	if (Keep) {
		if (putenv("Keep=") != 0)
			return FALSE;
	} else
		unset_env("Keep", 4);

	/* prevent GNU getopt (possibly used by external programs)
	 * from hallucinating options after non-option arguments */
	if (putenv("POSIXLY_CORRECT=") != 0)
		return FALSE;

	return TRUE;
}


BOOL set_extr_env(struct archive *arch) {
	char *main_var, *b;

	main_var = b = emalloc(5 + arch->pos);
	mem_cat(&b, "Name=", 5);
	mem_cat(&b, arch->file.e, arch->pos - 1);
	*b = 0;

	return putenv(main_var) == 0;
}
