#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>

#include "msg.h"
#include "str.h"



void msg(const char *type, const char *subtype, const char *id) {
	WRITE(2, "deco: ");
	WRITE(2, type);
	if (subtype) {
		WRITE(2, " (");
		WRITE(2, subtype);
		WRITE(2, ")");
	}
	if (id) {
		WRITE(2, ": ");
		WRITE(2, id);
	}
	WRITE(2, "\n");
}


void err(const char *type, const char *id) {
	msg(type, strerror(errno), id);
}


void die(const char *type, const char *id) {
	err(type, id);
	exit(1);
}


void *emalloc(size_t size) {
	void *res = malloc(size);
	if (res)
		return res;
	msg(MSG_ALLOC, NULL, NULL);
	exit(ENOMEM);
}
