#include <stdlib.h>

#include "bool.h"
#include "opts.h"
#include "parse.h"
#include "str.h"
#include "ver.h"



BOOL Absolute   = FALSE;
BOOL Keep       = FALSE;
BOOL Unlink     = FALSE;
BOOL Verbose    = FALSE;
char *Extension = NULL;
char **Archives = NULL;



static void usage(void) {
	char *s = "deco archive file extractor " VERSION " <http://hartlich.com/deco/>\n"
	          "\n"
	          "USAGE: deco [option...] archive...\n"
	          "\n"
	          "OPTIONS: -a      absolute (extract in archive's directory)\n"
	          "         -e ext  act as if archive's longest extension were .ext\n"
	          "         -k      keep partial contents if extraction fails\n"
	          "         -u      unlink archive and auxiliary files if successful\n"
	          "         -v      verbose\n";

	WRITE(2, s);
}


BOOL set_opts(char **argv) {
	char *opts = "aekuv";
	unsigned int arged[] = { 0, 1, 0, 0, 0 };
	void *vars[] = { &Absolute, &Extension, &Keep, &Unlink, &Verbose };
	unsigned int file_offset = parse_opts(argv, opts, arged, vars);

	if (!file_offset || argv[file_offset] == NULL) {
		usage();
		return FALSE;
	}

	Archives = argv + file_offset;
	return TRUE;
}
