#include <stdlib.h>

#include "bool.h"



unsigned int parse_opts(char **argv, char *opts, unsigned int *arged, void **vars) {
	unsigned int arg, letter, opt;
	BOOL opt_arg = FALSE, valid;

	for(arg = 1; argv[arg] != NULL; ++arg) {
		/* argument to a previous option? */
		if (opt_arg) {
			opt_arg = FALSE;
			continue;
		}

		/* not an option? */
		if (argv[arg][0] != '-' || argv[arg][1] == 0)
			break;

		/* option delimiter? */
		if (argv[arg][1] == '-' && argv[arg][2] == 0) {
			++arg;
			break;
		}

		/* For now, each option taking an argument is only allowed to occur
		 * once. We accept the -x arg style, but reject the deprecated -xarg
		 * and -yzxarg styles. */
		for (letter = 1; argv[arg][letter]; ++letter) {
			valid = FALSE;
			for (opt = 0; opts[opt]; ++opt) {
				if (argv[arg][letter] == opts[opt]) {
					if (arged[opt] == 0) {
						valid = TRUE;
						*(BOOL *)vars[opt] = TRUE;
					} else {
						if (
							!*(char **)vars[opt] &&
							letter == 1 &&
							argv[arg][letter + 1] == 0 &&
							argv[arg + 1] != NULL
						) {
							valid = opt_arg = TRUE;
							*(char **)vars[opt] = argv[arg + 1];
						}
					}
					break;
				}
			}
			if (!valid)
				return 0;
		}
	}
	return arg;
}
